/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.C
* Author             : WCH
* Version            : V1.3
* Date               : 2018-12-21 09:55:14
* Description        : CH554 SPI0 дSPI-Flash ʵUSB Mass Storage Device
*******************************************************************************/
#include <stdio.h>
#include <string.h>
#include "CH554.H"
#include "Debug.H"


sbit LED_Status = P3^4;     // Ч


#pragma  NOAREGS

#define THIS_ENDP0_SIZE     DEFAULT_ENDP0_SIZE
UINT8X  Ep0Buffer[THIS_ENDP0_SIZE + 2]      _at_ 0x0000;    // ˵0 OUT&IN, żַ
UINT8X  Ep1Buffer[2 * MAX_PACKET_SIZE + 4]  _at_ 0x000A;    // ˵1 OUT&IN, żַ
UINT8   UsbConfig = 0;
UINT8   UsbReady  = 0;


#define UsbSetupBuf     ((PUSB_SETUP_REQ)Ep0Buffer)

UINT8C  MyDevDescr[] =      // 豸
{
    0x12, 0x01, 0x10, 0x01,
    0x00, 0x00, 0x00, THIS_ENDP0_SIZE,
    0x44, 0x33, 0x33, 0x35,                                 // IDͲƷID
    0x00, 0x01, 0x01, 0x02,
    0x00, 0x01
};

UINT8C  MyCfgDescr[] =      // , ӿ, ˵
{
    0x09, 0x02, 0x20, 0x00, 0x01, 0x01, 0x00, 0x80, 0x32,   // 
    0x09, 0x04, 0x00, 0x00, 0x02, 0x08, 0x06, 0x50, 0x00,   // ӿ
    0x07, 0x05, 0x81, 0x02, 0x40, 0x00, 0x00,               // ϴ˵
    0x07, 0x05, 0x01, 0x02, 0x40, 0x00, 0x00                // ´˵
};

UINT8C  MyLangDescr[] =     // 
{
    4, 0x03, 0x09, 0x04
};

UINT8C  MyManuInfo[] =      // Ϣ
{
    14, 0x03, 'w', 0, 'c', 0, 'h', 0, '.', 0, 'c', 0, 'n', 0
};

UINT8C  MyProdInfo[] =      // ƷϢ
{
    12, 0x03, 'C', 0, 'H', 0, '5', 0, '5', 0, '4', 0
};

// Mass Storage
UINT8C  MAX_LUN[] = { 0 };

UINT8C  DBINQUITY[] =       // INQUIRY inform
{
    0x00,       // Peripheral Device Type
    0x80,       // 
    0x02,       // ISO/ECMA
    0x02,       // 
    0x1f,       // Additional Length

    0x00,       // Reserved
    0x00,       // Reserved
    0x00,       // Reserved

    'w',        // Vendor Information
    'c',
    'h',
    '.',
    'c',
    'n',
    ' ',
    ' ',

    0xc7,       // Product Identification
    0xdf,
    0xba,
    0xe3,
    0xb5,
    0xe7,
    0xd7,
    0xd3,
    0x55,
    0xc5,
    0xcc,
    0xb7,
    0xbd,
    0xb0,
    0xb8,
    0x00,

    '1',        // Product Revision Level
    '.',
    '1',
    '0'
};

// ޸ĺ㶨ʱע޸ĲǰΪ4kҪӦ޸ɡ
#define DISK_SEC_LEN    (UINT32)(4096UL)                                // С 4KB
#define DISK_SEC_NUM    (UINT32)((16 * 1024 * 1024UL) / DISK_SEC_LEN)   //  16MB/4KB
#define DISK_SEC_LAST   (UINT32)(DISK_SEC_NUM - 1)                      // һ߼ַ


UINT8C  DBCAPACITY[] =      // last logic addr// block lenth
{
    (DISK_SEC_LAST >> 24) & 0xFF, (DISK_SEC_LAST >> 16) & 0xFF, (DISK_SEC_LAST >> 8) & 0xFF, DISK_SEC_LAST & 0xFF, (DISK_SEC_LEN >> 24) & 0xFF, (DISK_SEC_LEN >> 16) & 0xFF, (DISK_SEC_LEN >> 8) & 0xFF, DISK_SEC_LEN & 0xFF
};

UINT8C  modesense3F[] =     // 
{
    0x0b, 0x00, 0x00, 0x08, (DISK_SEC_NUM >> 24) & 0xFF, (DISK_SEC_NUM >> 16) & 0xFF, (DISK_SEC_NUM >> 8) & 0xFF, DISK_SEC_NUM & 0xFF, 00, 00, 02, 00
};

UINT8C  mode5sense3F[] =    // 
{
    0x00, 0x06, 0x00, 0x00, 0x08, 0x00, 0x00, 0x08, (DISK_SEC_NUM >> 24) & 0xFF, (DISK_SEC_NUM >> 16) & 0xFF, (DISK_SEC_NUM >> 8) & 0xFF, DISK_SEC_NUM & 0xFF, 00, 00, 02, 00
};

typedef union _CBWCB
{
    unsigned char buf1[16];
} CBWCB;

typedef  union _MASS_PARA
{
    unsigned char buf[64];
    struct  _SENSE
    {
        unsigned char ErrorCode;
        unsigned char Reserved1;
        unsigned char SenseKey;
        unsigned char Information[4];
        unsigned char AddSenseLength;
        unsigned char Reserved2[4];
        unsigned char AddSenseCode;
        unsigned char AddSenseCodeQua;
        unsigned char Reserved3[4];
    } Sense;
    struct  _CBW
    {
        unsigned char dCBWsig[4];
        unsigned char dCBWTag[4];
        unsigned long dCBWDatL;
        unsigned char bmCBWFlags;
        unsigned char bCBWLUN;
        unsigned char bCBWCBLength;
        CBWCB        cbwcb;
    } cbw;
} MASS_PARA;

enum _HOST_DEV_DISAGREE
{
    CASEOK = 0,
    CASE1,
    CASE2,
    CASE3,
    CASE4,
    CASE5,
    CASE6,
    CASE7,
    CASE8,
    CASE9,
    CASE10,
    CASE11,
    CASE12,
    CASE13,
    CASECBW,
    CASECMDFAIL
};

#define FORMAT_UNIT             0x04
#define INQUIRY                 0x12
#define MODE_SELECT             0x15
#define MODE_SENSE5             0x5A
#define MODE_SENSE              0x1A
#define PER_RES_IN              0x5E
#define PER_RES_OUT             0x5F
#define PRE_OR_MED              0x1E
#define READ                    0x28
#define READ_CAPACITY           0x25
#define RELEASE                 0x17
#define REQUEST_SENSE           0x03
#define RESERVE                 0x16
#define STA_STO_UNIT            0x1B
#define SYN_CACHE               0x35
#define TES_UNIT                0x00
#define VERIFY                  0x2F
#define WRITE                   0x2A
#define WRITE_BUFFER            0x3B


union
{
    unsigned long mDataLength;                      // ݳ
    unsigned char mdataLen[4];
} LEN;

MASS_PARA idata MassPara;
unsigned char mdCBWTag[4];                          // dCBWTag
bit CH375BULKUP;                                    // ϴ
bit CH375BULKDOWN;                                  // ´
bit CH375CSW;                                       // CSWϴ־
unsigned char BcswStatus;                           // CSW״̬
unsigned char mSenseKey;
unsigned char mASC;
bit FSTALL;                                         // ݴ־
bit lastFSTALL;
bit pBuf_ReSelect = 0;
UINT32 Locate_Addr;
unsigned char *pBuf;


/*******************************************************************************
* Function Name  : USBDeviceCfg()
* Description    : USB豸ģʽ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void    InitUSB_Device(void)                                    // ʼUSB豸
{
    USB_CTRL = 0x00;                                            // USBƼĴ
    USB_CTRL &= ~bUC_HOST_MODE;                                 // λΪѡ豸ģʽ
    USB_CTRL |=  bUC_DEV_PU_EN | bUC_INT_BUSY | bUC_DMA_EN;     // USB豸ڲʹ,жڼжϱ־δǰԶNAK
    USB_DEV_AD = 0x00;                                          // 豸ַʼ
//  USB_CTRL |= bUC_LOW_SPEED;
//  UDEV_CTRL |= bUD_LOW_SPEED;                                 // ѡ1.5Mģʽ
    USB_CTRL &= ~bUC_LOW_SPEED;
    UDEV_CTRL &= ~bUD_LOW_SPEED;                                // ѡȫ12MģʽĬϷʽ
    UDEV_CTRL = bUD_PD_DIS;                                     // ֹDP/DM
    UDEV_CTRL |= bUD_PORT_EN;                                   // ʹ˿

	UEP1_DMA = Ep1Buffer;                                       // ˵1 ݴַ
    UEP4_1_MOD = 0xC0;                                          // ˵1´˵064ֽշ
    UEP1_CTRL = bUEP_AUTO_TOG | UEP_T_RES_NAK | UEP_R_RES_ACK;  // ˵1Զתͬ־λIN񷵻NAKOUTACK
	UEP0_DMA = Ep0Buffer;                                       // ˵0ݴַ
    UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;                  // ֶתOUT񷵻ACKIN񷵻NAK
	UEP0_T_LEN = 0;
    UEP1_T_LEN = 0;                                             // Ԥʹ÷ͳһҪ

    USB_INT_EN |= bUIE_SUSPEND;                                 // ʹ豸ж
    USB_INT_EN |= bUIE_TRANSFER;                                // ʹUSBж
    USB_INT_EN |= bUIE_BUS_RST;                                 // ʹ豸ģʽUSB߸λж
    USB_INT_FG |= 0x1F;                                         // жϱ־
    IE_USB = 1;                                                 // ʹUSBж
    EA = 1;                                                     // Ƭж
}


sbit SPI_CS = P1 ^ 4;
#define SPI_Tx( d )    { SPI0_DATA = d; while(S0_FREE == 0); }
#define SPI_Rx( d )    { SPI0_DATA = 0xFF; while(S0_FREE == 0); d = SPI0_DATA; }


/*******************************************************************************
* Function Name  : InitHostSPI0( void )
* Description    : SPI0ģʽʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void InitHostSPI0(void)
{
    SPI0_SETUP &= ~(bS0_MODE_SLV | bS0_BIT_ORDER);              // Masterģʽ, λǰ
    SPI0_CTRL = bS0_SCK_OE | bS0_MOSI_OE;                       // ģʽ0
    SPI0_CK_SE = 0x02;                                          // 2Ƶ
    P1_MOD_OC |= (bMOSI | bMISO | bSCK | bSCS);
    P1_DIR_PU |= (bMOSI | bMISO | bSCK | bSCS);
}

/*******************************************************************************
* Function Name  : ReadFlashStatus
* Description    : ȡ״̬Ĵ,״̬Ĵֵ
* Input          : None
* Output         : None
* Return         : ExFlashRegStatus
*******************************************************************************/
UINT8 ReadFlashStatus(void)
{
    UINT8 FlashStatus;

    SPI_CS = 0;
    SPI_Tx(0x05);                                       // Read Status Register
    SPI_Rx(FlashStatus);                                // ȡ״̬Ĵ
    SPI_CS = 1;

    return FlashStatus;
}

/*******************************************************************************
* Function Name  : WaitFlashBusy
* Description    : ȴоƬ(ִByte-Program, Sector-Erase, Block-Erase, Chip-Erase)
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void WaitFlashBusy(void)
{
    while((ReadFlashStatus()) & 0x01 == 0x01);          // ȴֱFlash
}

/*******************************************************************************
* Function Name  : WriteFlashStatus
* Description    : ״̬Ĵдһֽ
* Input          : status -д
* Output         : None
* Return         : None
*******************************************************************************/
void WriteFlashStatus(UINT8 status)
{
    SPI_CS = 0;
    SPI_Tx(0x01);                                       // Write Status Register
    SPI_Tx(status);                                     // ıĴBPxBPL(ֻ2,3,4,5,7λԸд)
    SPI_CS = 1;
}

/*******************************************************************************
* Function Name  : WriteFlashForbidden
* Description    : дֹ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void WriteFlashForbidden(void)
{
    SPI_CS = 0;
    SPI_Tx(0x04);
    SPI_CS = 1;
}

/*******************************************************************************
* Function Name  : WriteFlashEnable
* Description    : дʹ, ͬʹд״̬Ĵ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void WriteFlashEnable(void)
{
    SPI_CS = 0;
    SPI_Tx(0x06);                                       // Write Enable
    SPI_CS = 1;
}

/*******************************************************************************
* Function Name  : CheckFlashWriteEnable
* Description    : дǰWELλǷΪ1
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CheckFlashWriteEnable(void)
{
    UINT8 WRENStatus;
    
    WRENStatus = ReadFlashStatus();                     // ȡ״̬register
    if((WRENStatus & 0x02) != 0x02)                     // WELλλ
    {
        WriteFlashEnable();                             // δ1Ӧ,дʹܲ
    }
}

/*******************************************************************************
* Function Name  : EraseFlash
* Description    : 4K Flash  һ
* Input          : Dst_Addr 0-1 ffff ffff ,ַڵ
* Output         : None
* Return         : None
*******************************************************************************/
void EraseFlash(UINT32 Dst_Addr)
{
    CheckFlashWriteEnable();
    SPI_CS = 0;
    SPI_Tx(0x20);                                       // 
    SPI_Tx(((Dst_Addr & 0xFFFFFF) >> 16));              // send 3 address bytes
    SPI_Tx(((Dst_Addr & 0xFFFF) >> 8));
    SPI_Tx(Dst_Addr & 0xFF);
    SPI_CS = 1;
    WaitFlashBusy();
}

/*******************************************************************************
* Function Name  : ByteReadFlash
* Description    : ȡһַһֽڵ.ضȡ
* Input          : UINT32 StarAddr -Destination Address 000000H - 1FFFFFH
* Output         : None
* Return         : byte -ȡ
*******************************************************************************/
UINT8 ByteReadFlash(UINT32 StarAddr)
{
    UINT8 dat = 0;

    SPI_CS = 0;
    SPI_Tx(0x03);                                       // read command
    SPI_Tx(((StarAddr & 0xFFFFFF) >> 16));              // send 3 address bytes
    SPI_Tx(((StarAddr & 0xFFFF) >> 8));
    SPI_Tx(StarAddr & 0xFF);
    SPI_Rx(dat);
    SPI_CS = 1;

    return dat;                                         // return one byte read
}

/*******************************************************************************
* Function Name  : ByteWriteFlash
* Description    : д
* Input          : StarAddr  -Destination Address 000000H - 1FFFFFH
*                  dat -Ҫд
* Output         : None
* Return         : None
*******************************************************************************/
void ByteWriteFlash(UINT32 StarAddr, UINT8 dat)
{
    WriteFlashEnable();
    SPI_CS = 0;
    SPI_Tx(0x02);                                       // Page Program
    SPI_Tx(((StarAddr & 0xFFFFFF) >> 16));              // 3ֽڵַ
    SPI_Tx(((StarAddr & 0xFFFF) >> 8));
    SPI_Tx(StarAddr & 0xFF);
    SPI_Tx(dat);                                        // Ҫд
    SPI_CS = 1;
    WaitFlashBusy();
}

/*******************************************************************************
* Function Name  : BulkReadFlash
* Description    : ȡʼַ(StarAddr)ڶֽ(Len).뻺RcvBuffer
* Input          : StarAddr -Destination Address 000000H - 1FFFFFH
                   Len ȡݳ
                   RcvBuffer ջʼַ
* Output         : None
* Return         : None
*******************************************************************************/
void BulkReadFlash(UINT32 StarAddr, UINT16 Len, PUINT8 RcvBuffer)
{
    UINT16 i;

    LED_Status = 1;
    SPI_CS = 0;
    SPI_Tx(0x0b);                                       // fast read command
    SPI_Tx(((StarAddr & 0xFFFFFF) >> 16));              // send 3 address bytes
    SPI_Tx(((StarAddr & 0xFFFF) >> 8));
    SPI_Tx(StarAddr & 0xFF);
    SPI_Tx(0x00);
    for(i = 0; i < Len; i++)
    {
        SPI_Rx(RcvBuffer[i]);                           // 
    }
    SPI_CS = 1;
}

/*******************************************************************************
* Function Name  : BulkWriteFlash
* Description    : дⲿFlash
* Input          : StarAddr  -Destination Address 000000H - 1FFFFFH
                   Len ݳ
*                  SendBuffer -ݻ
* Output         : None
* Return         : None
*******************************************************************************/
void BulkWriteFlash(UINT32 StarAddr, UINT16 Len, PUINT8 SendBuffer)
{
    UINT16 i;

    LED_Status = 1;
    WaitFlashBusy();                                // ȴFlashæ
    WriteFlashStatus(0x00);                         // оƬΪޱ
    WriteFlashEnable();                             // дʹ

    SPI_CS = 0;
    SPI_Tx(0x02);                                   // Page Program
    SPI_Tx(((StarAddr & 0xFFFFFF) >> 16));          // 3ֽڵַ
    SPI_Tx(((StarAddr & 0xFFFF) >> 8));
    SPI_Tx(StarAddr & 0xFF);
    for(i = 0; i < Len; i++)
    {
        SPI_Tx(SendBuffer[i]);
    }
    SPI_CS = 1;
    WriteFlashForbidden();                          // дֹ
    WaitFlashBusy();                                // ȴFlashæ
}


void main(void)
{
    CfgFsys();                                      // CH554ʱѡ
    mDelaymS(10);                                   // ϵʱ,ȴڲȶ,ؼ
    mInitSTDIO();                                   // Ϊüͨڼʾ
    printf("CH5%02X\n", (UINT16)CHIP_ID);

    InitHostSPI0();
    WriteFlashEnable();                             // FLASHдʹ
    WriteFlashStatus(0x00);                         // оƬΪޱ
    printf("SPI Flash Init OK\n");
    
    InitUSB_Device();
    while(!UsbReady);
    printf("USB Disk Init OK\n");
    
    while(1)
    {
        mDelaymS(100);
    }
}

// BLOCK ONLY  The Thirteen Cases
void  BulkThirteen(unsigned char Case)
{
    switch(Case)
    {
        case CASEOK:
        case CASE1:                                         /* Hn=Dn*/
        case CASE6:                                         /* Hi=Di*/
            BcswStatus = 0;
            break;
        case CASE12:                                        /* Ho=Do*/
            BcswStatus = 0;
            break;
        case CASE2:                                         /* Hn<Di*/
        case CASE3:                                         /* Hn<Do*/
            UEP1_CTRL = UEP1_CTRL | MASK_UEP_T_RES ;
            FSTALL = 1;
            // ϴ˵һSTALL // may or may-not
            BcswStatus = 2;
            break;
        case CASE4:                                         /* Hi>Dn*/
        case CASE5:                                         /* Hi>Di*/
            UEP1_CTRL = UEP1_CTRL | MASK_UEP_T_RES ;
            FSTALL = 1;
            // ϴ˵һSTALL
            BcswStatus = 1;                                 // CSW_GOOD or CSW_FAIL
            break;
        case CASE7:                                         /* Hi<Di*/
        case CASE8:                                         /* Hi<>Do */
            UEP1_CTRL = UEP1_CTRL | MASK_UEP_T_RES ;
            FSTALL = 1;
            // ϴ˵һSTALL
            BcswStatus = 2;
            break;
        case CASE9:                                         /* Ho>Dn*/
        case CASE11:                                        /* Ho>Do*/
            UEP1_CTRL = UEP1_CTRL | MASK_UEP_R_RES ;
            FSTALL = 1;
            // ϴ˵һSTALL
            BcswStatus = 1;                                 // CSW_GOOD or CSW_FAIL
            break;
        case CASE10:                                        /* Ho<>Di */
        case CASE13:                                        /* Ho<Do*/
            UEP1_CTRL = UEP1_CTRL | MASK_UEP_T_RES ;
            FSTALL = 1;
            // ϴ˵һSTALL
            UEP1_CTRL = UEP1_CTRL | MASK_UEP_R_RES ;
            // ϴ˵һSTALL
            BcswStatus = 2;
            break;
        case CASECBW:                                       /* invalid CBW */
            UEP1_CTRL = UEP1_CTRL | MASK_UEP_T_RES ;
            FSTALL = 1;
            UEP1_CTRL = UEP1_CTRL | MASK_UEP_R_RES ;
            // ˵һSTALL
            BcswStatus = 2;
            break;
        case CASECMDFAIL:
            UEP1_CTRL = UEP1_CTRL | MASK_UEP_T_RES ;
            FSTALL = 1;
            // ϴ˵һSTALL
            BcswStatus = 1;
            break;
        default:
            break;
    }
}

// ѯU
void  UFI_readCapacity(void)
{
    pBuf = DBCAPACITY;
    if(LEN.mDataLength > sizeof(DBCAPACITY))
        LEN.mDataLength = sizeof(DBCAPACITY);
    BcswStatus  = 0;
    mSenseKey   = 0;
    mASC        = 0;
}

// ѯUϢ
void  UFI_inquiry(void)
{
    pBuf = DBINQUITY;
    if(LEN.mDataLength > sizeof(DBINQUITY))
        LEN.mDataLength = sizeof(DBINQUITY);
    BcswStatus  = 0;
    mSenseKey   = 0;
    mASC        = 0;
}

// ȡ
void  UFI_read10(void)
{
    LEN.mDataLength = (((UINT32)MassPara.cbw.cbwcb.buf1[7] << 8) | (UINT32)MassPara.cbw.cbwcb.buf1[8]) * DISK_SEC_LEN;
    Locate_Addr = ((UINT32)MassPara.cbw.cbwcb.buf1[2] << 24) | ((UINT32)MassPara.cbw.cbwcb.buf1[3] << 16) | ((UINT32)MassPara.cbw.cbwcb.buf1[4] << 8) | (UINT32)MassPara.cbw.cbwcb.buf1[5];
    Locate_Addr = Locate_Addr * DISK_SEC_LEN;
//  printf("Read addr:%ld  len:%ld \n", Locate_Addr, LEN.mDataLength);
    BcswStatus = 0;
    mSenseKey = 0;
    mASC = 0;
    pBuf_ReSelect = 1;
}

// ģʽʶ
void  UFI_modeSense(void)
{
    if(MassPara.cbw.cbwcb.buf1[2] == 0x3F)
    {
        if(LEN.mDataLength > sizeof(modesense3F)) LEN.mDataLength = sizeof(modesense3F);
        pBuf = modesense3F;
        BcswStatus = 0;
        mSenseKey = 0;
        mASC = 0;
    }
    else
    {
        CH375BULKUP = 0;
        mSenseKey = 5;
        mASC = 0x20;
        BcswStatus = 1;
        BulkThirteen(CASECMDFAIL);
    }
}

// ʶ
void  UFI_requestSense(void)
{
    if(FSTALL | lastFSTALL)
    {
        lastFSTALL = FSTALL;
        FSTALL = 0;
        MassPara.Sense.ErrorCode = 0x70;
        MassPara.Sense.Reserved1 = 0;
        MassPara.Sense.SenseKey = mSenseKey;
        MassPara.Sense.Information[0] = 0;
        MassPara.Sense.Information[1] = 0;
        MassPara.Sense.Information[2] = 0;
        MassPara.Sense.Information[3] = 0;
        MassPara.Sense.AddSenseLength = 0x0a;
        MassPara.Sense.Reserved2[0] = 0;
        MassPara.Sense.Reserved2[1] = 0;
        MassPara.Sense.Reserved2[2] = 0;
        MassPara.Sense.Reserved2[3] = 0;
        MassPara.Sense.AddSenseCode = mASC;
        MassPara.Sense.AddSenseCodeQua = 00;
        MassPara.Sense.Reserved3[0] = 0;
        MassPara.Sense.Reserved3[1] = 0;
        MassPara.Sense.Reserved3[2] = 0;
        MassPara.Sense.Reserved3[3] = 0;
        pBuf = MassPara.buf;
        BcswStatus = 0;
    }
    else
    {
        lastFSTALL = FSTALL;
        FSTALL = 0;
        MassPara.Sense.ErrorCode = 0x70;
        MassPara.Sense.Reserved1 = 0;
        MassPara.Sense.SenseKey = 0x00;
        MassPara.Sense.Information[0] = 0;
        MassPara.Sense.Information[1] = 0;
        MassPara.Sense.Information[2] = 0;
        MassPara.Sense.Information[3] = 0;
        MassPara.Sense.AddSenseLength = 0x0a;
        MassPara.Sense.Reserved2[0] = 0;
        MassPara.Sense.Reserved2[1] = 0;
        MassPara.Sense.Reserved2[2] = 0;
        MassPara.Sense.Reserved2[3] = 0;
        MassPara.Sense.AddSenseCode = 0x00;
        MassPara.Sense.AddSenseCodeQua = 00;
        MassPara.Sense.Reserved3[0] = 0;
        MassPara.Sense.Reserved3[1] = 0;
        MassPara.Sense.Reserved3[2] = 0;
        MassPara.Sense.Reserved3[3] = 0;
        pBuf = MassPara.buf;
        BcswStatus = 0;
    }
}

// UǷ׼
void  UFI_testUnit(void)
{
    CH375BULKDOWN = 0;
    CH375BULKUP = 0;
    BcswStatus = 0;
    mSenseKey = 0;
    mASC = 0;
}

// Ƴ
void  UFI_perOrMed(void)
{
    BcswStatus = 0;
    mSenseKey = 0;
    mASC = 0;
}

// д
void  UFI_write(void)
{
    UINT8 i, num;

    LEN.mDataLength = (((UINT32)MassPara.cbw.cbwcb.buf1[7] << 8) | (UINT32)MassPara.cbw.cbwcb.buf1[8]) * DISK_SEC_LEN;      // дݳ
    Locate_Addr = ((UINT32)MassPara.cbw.cbwcb.buf1[2] << 24) | ((UINT32)MassPara.cbw.cbwcb.buf1[3] << 16) | ((UINT32)MassPara.cbw.cbwcb.buf1[4] << 8) | (UINT32)MassPara.cbw.cbwcb.buf1[5];
    Locate_Addr = Locate_Addr * DISK_SEC_LEN;       // дݵַ
    num = MassPara.cbw.cbwcb.buf1[8];               // д
    for(i = 0; i < num; i++)
        EraseFlash(Locate_Addr + i * DISK_SEC_LEN); // 
    BcswStatus = 0;
    mSenseKey = 0;
    mASC = 0;
}

// װж豸
void  UFI_staStoUnit(void)
{
    CH375BULKDOWN = 0;
    CH375BULKUP = 0;
    BcswStatus = 0;
    mSenseKey = 0;
    mASC = 0;
}

// У洢ռ
void  UFI_verify(void)
{
    BcswStatus = 0;
    mSenseKey = 0;
    mASC = 0;
    // ֻΪʾû洢
    // ʵһһҪ
}

void  UFI_modeSense5(void)
{
    if(MassPara.cbw.cbwcb.buf1[2] == 0x3F)
    {
        if(LEN.mDataLength > sizeof(mode5sense3F))
            LEN.mDataLength = sizeof(mode5sense3F);
        pBuf = mode5sense3F;
        BcswStatus = 0;
        mSenseKey = 0;
        mASC = 0;
    }
    else
    {
        CH375BULKUP = 0;
        mSenseKey = 5;
        mASC = 0x20;
        BcswStatus = 1;
        BulkThirteen(CASECMDFAIL);
    }
}

// UFI CMD
void UFI_Hunding(void)
{
    switch(MassPara.cbw.cbwcb.buf1[0])
    {
        case INQUIRY:
            UFI_inquiry();
            break;
        case WRITE:
            UFI_write();
            break;
        case TES_UNIT:
            UFI_testUnit();
            break;
        case READ:
            UFI_read10();
            break;
        case REQUEST_SENSE:
            UFI_requestSense();
            break;
        case READ_CAPACITY:
            UFI_readCapacity();
            break;
        case VERIFY:
            UFI_verify();
            break;
//      case 0x23:
//          break;
//      case MODE_SELECT:
//          UFI_modeSlect();
//          break;
        case MODE_SENSE:
            UFI_modeSense();
            break;
        case MODE_SENSE5:
            UFI_modeSense5();
            break;
//      case WRITE_BUFFER:
//          UFI_writeBuf();
//          break;
//      case PREVENT:
//          break;
//      case FORMAT_UNIT:
//          UFI_format();
//          break;
//      case RELEASE:
//          break;
        case STA_STO_UNIT:
            UFI_staStoUnit();
            break;
        case PRE_OR_MED:
            UFI_perOrMed();
            break;
        default:
         // printf("%2x\n",(UINT16)MassPara.cbw.cbwcb.buf1[0]);
            mSenseKey = 5;
            mASC = 0x20;
            BcswStatus = 1;
            CH375BULKUP = 0;
            BulkThirteen(CASECBW);
            break;
    }
}

void mCH375BulkOnly()
{
    if(MassPara.buf[0] == 0x55)
    {
        if(MassPara.buf[1] == 0x53)
        {
            if(MassPara.buf[2] == 0x42)
            {
                if(MassPara.buf[3] == 0x43)
                {
//                  LEN.mDataLength = BIG_ENDIAN(MassPara.cbw.dCBWDatL);            // BOЭ鴦
                    LEN.mdataLen[3] = *(unsigned char *)(&MassPara.cbw.dCBWDatL);   /* PCĵֽǰ16λתΪC51ĸֽǰ */
                    LEN.mdataLen[2] = *((unsigned char *)(&MassPara.cbw.dCBWDatL) + 1);
                    LEN.mdataLen[1] = *((unsigned char *)(&MassPara.cbw.dCBWDatL) + 2);
                    LEN.mdataLen[0] = *((unsigned char *)(&MassPara.cbw.dCBWDatL) + 3);
                    mdCBWTag[0] = MassPara.buf[4];
                    mdCBWTag[1] = MassPara.buf[5];
                    mdCBWTag[2] = MassPara.buf[6];
                    mdCBWTag[3] = MassPara.buf[7];                89272965
                                      // ȡݳ
                    if(LEN.mDataLength)
                    {
                        CH375BULKDOWN   = (MassPara.cbw.bmCBWFlags & 0x80) ? 0 : 1; // ´(OUT)
                        CH375BULKUP     = (MassPara.cbw.bmCBWFlags & 0x80) ? 1 : 0; // ϴ(IN)
                    }
                    CH375CSW = 1;
                    UFI_Hunding();  // UFIЭ鴦
                }
                else
                    UEP1_CTRL = UEP1_CTRL | MASK_UEP_T_RES ;
            }
            else
                UEP1_CTRL = UEP1_CTRL | MASK_UEP_T_RES ;
        }
        else
            UEP1_CTRL = UEP1_CTRL | MASK_UEP_T_RES ;
    }
    else
        UEP1_CTRL = UEP1_CTRL | MASK_UEP_T_RES ;
}

// ϴCSW
void mCH375UpCsw()
{
    unsigned char i;
    
    pBuf = &MassPara.buf[0];
    CH375CSW = 0;
    CH375BULKUP = 0;            // ȡϴ
    MassPara.buf[0] = 0x55;     // dCSWSignature
    MassPara.buf[1] = 0x53;
    MassPara.buf[2] = 0x42;
    MassPara.buf[3] = 0x53;
    MassPara.buf[4] = mdCBWTag[0];
    MassPara.buf[5] = mdCBWTag[1];
    MassPara.buf[6] = mdCBWTag[2];
    MassPara.buf[7] = mdCBWTag[3];
    MassPara.buf[8] = 0;
    MassPara.buf[9] = 0;
    MassPara.buf[10] = LEN.mdataLen[1];
    MassPara.buf[11] = LEN.mdataLen[0];
    MassPara.buf[12] = BcswStatus;
    for(i = 0; i < 13; i++)
    {
        Ep1Buffer[MAX_PACKET_SIZE + i] = *pBuf;
        pBuf++;
    }
    UEP1_T_LEN = 13;
    UEP1_CTRL = UEP1_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_ACK;  // ϴ
    LED_Status = 0;
}

// ˵1ϴ(IN)
void mCH375bulkUpData()
{
    unsigned char len, i;
    
    if(LEN.mDataLength > 0x40)
    {
        len = 0x40;
        LEN.mDataLength -= 0x40;
    }
    else
    {
        len = (unsigned char) LEN.mDataLength;
        LEN.mDataLength = 0;
        CH375BULKUP = 0;
    }
    if(pBuf_ReSelect)
    {
        BulkReadFlash(Locate_Addr, len, &Ep1Buffer[MAX_PACKET_SIZE]);
        Locate_Addr += len;
        if(LEN.mDataLength == 0)
            pBuf_ReSelect = 0;
    }
    else
    {
        for(i = 0; i < len; i++)
        {
            Ep1Buffer[MAX_PACKET_SIZE + i] = *pBuf;
            pBuf++;
        }
    }
    UEP1_T_LEN = len;
    UEP1_CTRL = UEP1_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_ACK;  // ϴ
}

UINT8I buffer[64];
// ˵1´(OUT)
void mCH375BulkDownData()
{
    unsigned char len, i;

    len = USB_RX_LEN;
    for(i = 0; i != len; i++)
        buffer[i] = Ep1Buffer[i];   // ݶ뵽
    BulkWriteFlash(Locate_Addr, len, &buffer[0]);
    Locate_Addr += len;
    LEN.mDataLength -= len;         // ȫݳȼǰõĳ
    if(LEN.mDataLength == 0)        // Ϊ0, CSW
    {
        CH375BULKDOWN = 0;          // ´
        mCH375UpCsw();              // ϴCSW
    }
}

/*******************************************************************************
* Function Name  : USB_DeviceInterrupt()
* Description    : CH554 USBģжϴ
*******************************************************************************/
void    USB_DeviceInterrupt(void) interrupt INT_NO_USB using 1                  // USBжϷ, ʹüĴ1
{
    UINT8   len, i;
    static  UINT8   SetupReqCode, SetupLen;
    static  PUINT8  pDescr;

    if(UIF_TRANSFER)                                                            // USB
    {
        switch(USB_INT_ST & (MASK_UIS_TOKEN | MASK_UIS_ENDP))                   // ƺͶ˵
        {
            case UIS_TOKEN_IN | 1:                                              // endpoint 1# ˵ϴ
            {
                if(CH375BULKUP) mCH375bulkUpData();                             // ϴ
                else if(CH375CSW) mCH375UpCsw();                                // ϴCSW
                else
                    UEP1_CTRL = UEP1_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_NAK;   // ͣϴ
                break;
            }
            case UIS_TOKEN_OUT | 1:                                             // endpoint 1# ˵´
            {
                if(U_TOG_OK)                                                    // ͬݰ
                {
                    if(CH375BULKDOWN)  mCH375BulkDownData();                    // ϴݽ׶ϴ
                    else                                                        // ´жǷ
                    {
                        len = USB_RX_LEN;
                        if(!len)break;                                          // ݰΪ
                        for(i = 0; i != len; i++)
                            MassPara.buf[i] = Ep1Buffer[i];                     // ݶ뵽
                        mCH375BulkOnly();
                        if(!CH375BULKDOWN)
                        {
                            if(CH375BULKUP) mCH375bulkUpData();                 // ϴ
                            else if(!FSTALL) mCH375UpCsw();                     // ûϴCSWϴ
                            // ϴݵ
                        }
                    }
                }
                break;
            }
            case UIS_TOKEN_SETUP | 0:                                           // endpoint 0# SETUP
            {
                len = USB_RX_LEN;
                if(len == sizeof(USB_SETUP_REQ))                                // SETUP
                {
                    SetupLen = UsbSetupBuf->wLengthL;
                    if(UsbSetupBuf->wLengthH || SetupLen > 0x7F)
                    {
                        SetupLen = 0x7F;                                        // ܳ
                    }
                    len = 0;                                                    // ĬΪɹϴ0
                    if((UsbSetupBuf->bRequestType & USB_REQ_TYP_MASK) != USB_REQ_TYP_STANDARD)  // 
                    {
                        SetupReqCode = UsbSetupBuf->bRequest;
                        if(SetupReqCode == 0xFE)                                // GET MAX LUN
                        {
                            pDescr = (PUINT8)(&MAX_LUN[0]);
                            len = 1;
                            if(SetupLen > len)
                            {
                                SetupLen = len;                                 // ܳ
                            }
                            len = SetupLen >= THIS_ENDP0_SIZE ? THIS_ENDP0_SIZE : SetupLen;  // δ䳤
                            memcpy(Ep0Buffer, pDescr, len);                     // ϴ
                            SetupLen -= len;
                            pDescr += len;
                            UsbReady = 1;
                        }
                    }
                    else                                                        // ׼
                    {
                        SetupReqCode = UsbSetupBuf->bRequest;
                        switch(SetupReqCode)                                    // 
                        {
                            case USB_GET_DESCRIPTOR:
                                switch(UsbSetupBuf->wValueH)
                                {
                                    case USB_DESCR_TYP_DEVICE:                  // 豸
                                        pDescr = MyDevDescr;
                                        len = sizeof(MyDevDescr);
                                        break;
                                    case USB_DESCR_TYP_CONFIG:                  // 
                                        pDescr = MyCfgDescr;
                                        len = sizeof(MyCfgDescr);
                                        break;
                                    case USB_DESCR_TYP_STRING:                  // ַ
                                        switch(UsbSetupBuf->wValueL)
                                        {
                                            case 0:
                                                pDescr = MyLangDescr;
                                                len = sizeof(MyLangDescr);
                                                break;
                                            case 1:
                                                pDescr = MyManuInfo;
                                                len = sizeof(MyManuInfo);
                                                break;
                                            case 2:
                                                pDescr = MyProdInfo;
                                                len = sizeof(MyProdInfo);
                                                break;
                                            default:
                                                len = 0xFF;                     // ֵַ֧
                                                break;
                                        }
                                        break;
                                    default:
                                        len = 0xFF;                             // ֵ֧
                                        break;
                                }
                                if(SetupLen > len)
                                {
                                    SetupLen = len;                             // ܳ
                                }
                                len = SetupLen >= THIS_ENDP0_SIZE ? THIS_ENDP0_SIZE : SetupLen; // δ䳤
                                memcpy(Ep0Buffer, pDescr, len);                 // ϴ
                                SetupLen -= len;
                                pDescr += len;
                                break;
                            case USB_SET_ADDRESS:
                                SetupLen = UsbSetupBuf->wValueL;                // ݴUSB豸ַ
                                break;
                            case USB_GET_CONFIGURATION:
                                Ep0Buffer[0] = UsbConfig;
                                if(SetupLen >= 1)
                                {
                                    len = 1;
                                }
                                break;
                            case USB_SET_CONFIGURATION:
                                UsbConfig = UsbSetupBuf->wValueL;
                                printf("Config\n");
                                break;
                            case USB_CLEAR_FEATURE:
                                if((UsbSetupBuf->bRequestType & USB_REQ_RECIP_MASK) == USB_REQ_RECIP_ENDP)  // ˵
                                {
                                    switch(UsbSetupBuf->wIndexL)
                                    {
                                        case 0x82:
                                            UEP2_CTRL = UEP2_CTRL & ~(bUEP_T_TOG | MASK_UEP_T_RES) | UEP_T_RES_NAK;
                                            break;
                                        case 0x02:
                                            UEP2_CTRL = UEP2_CTRL & ~(bUEP_R_TOG | MASK_UEP_R_RES) | UEP_R_RES_ACK;
                                            break;
                                        case 0x81:
                                            UEP1_CTRL = UEP1_CTRL & ~(bUEP_T_TOG | MASK_UEP_T_RES) | UEP_T_RES_NAK;
                                            if(CH375CSW) mCH375UpCsw();
                                            lastFSTALL = FSTALL;
                                            FSTALL = 0;
                                            break;
                                        case 0x01:
                                            UEP1_CTRL = UEP1_CTRL & ~(bUEP_R_TOG | MASK_UEP_R_RES) | UEP_R_RES_ACK;
                                            if(CH375CSW) mCH375UpCsw();
                                            lastFSTALL = FSTALL;
                                            FSTALL = 0;
                                            break;
                                        default:
                                            len = 0xFF;                         // ֵ֧Ķ˵
                                            break;
                                    }
                                }
                                else
                                {
                                    len = 0xFF;                                 // Ƕ˵㲻֧
                                }
                                break;
                            case USB_GET_INTERFACE:
                                Ep0Buffer[0] = 0x00;
                                if(SetupLen >= 1)
                                {
                                    len = 1;
                                }
                                break;
                            case USB_GET_STATUS:
                                Ep0Buffer[0] = 0x00;
                                Ep0Buffer[1] = 0x00;
                                if(SetupLen >= 2)
                                {
                                    len = 2;
                                }
                                else
                                {
                                    len = SetupLen;
                                }
                                break;
                            default:
                                len = 0xFF;                                     // ʧ
                                break;
                        }
                    }
                }
                else
                {
                    len = 0xFF;                                                 // SETUPȴ
                }
                
                if(len == 0xFF)                                                 // ʧ
                {
                    SetupReqCode = 0xFF;
                    UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_STALL | UEP_T_RES_STALL;// STALL
                }
                else if(len <= THIS_ENDP0_SIZE)                                 // ϴݻ״̬׶η0Ȱ
                {
                    UEP0_T_LEN = len;
                    UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;    // ĬݰDATA1
                }
                else                                                            // ´ݻ
                {
                    UEP0_T_LEN = 0;                                             // Ȼδ״̬׶ΣǰԤϴ0ݰԷǰ״̬׶
                    UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;    // ĬݰDATA1
                }
                break;
            }
            case UIS_TOKEN_IN | 0:                                              // endpoint 0# IN
            {
                switch(SetupReqCode)
                {
                    case USB_GET_DESCRIPTOR:
                        len = SetupLen >= THIS_ENDP0_SIZE ? THIS_ENDP0_SIZE : SetupLen; // δ䳤
                        memcpy(Ep0Buffer, pDescr, len);                         // ϴ
                        SetupLen -= len;
                        pDescr += len;
                        UEP0_T_LEN = len;
                        UEP0_CTRL ^= bUEP_T_TOG;                                // ת
                        break;
                    case USB_SET_ADDRESS:
                        USB_DEV_AD = USB_DEV_AD & bUDA_GP_BIT | SetupLen;
                        UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                        break;
                    default:
                        UEP0_T_LEN = 0;                                         // ״̬׶жϻǿϴ0ݰƴ
                        UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                        break;
                }
                break;
            }
            case UIS_TOKEN_OUT | 0:                                             // endpoint 0# OUT
            {
                UEP0_T_LEN = 0;
                UEP0_CTRL ^= bUEP_R_TOG;
                break;
            }
            default:
                break;
        }
        UIF_TRANSFER = 0;                                                       // жϱ־
    }
    else if(UIF_BUS_RST)                                                        // USB߸λ
    {
        printf("Reset\n");
        UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
        UEP1_CTRL = bUEP_AUTO_TOG | UEP_R_RES_ACK | UEP_T_RES_NAK;
        USB_DEV_AD = 0x00;
        UIF_SUSPEND = 0;
        UIF_TRANSFER = 0;
        UIF_BUS_RST = 0;                                                        // жϱ־
        UsbReady = 0;
    }
    else if(UIF_SUSPEND)                                                        // USB߹/
    {
        UIF_SUSPEND = 0;
        if(USB_MIS_ST & bUMS_SUSPEND)                                           // 
        {
            printf("Suspend\n");                                                // ˯״̬
            /*
            while(XBUS_AUX & bUART0_TX);                                        // ȴ
            SAFE_MOD = 0x55;
            SAFE_MOD = 0xAA;
            WAKE_CTRL = bWAK_BY_USB | bWAK_RXD0_LO;                             // USBRXD0źʱɱ
            PCON |= PD;                                                         // ˯
            SAFE_MOD = 0x55;
            SAFE_MOD = 0xAA;
            WAKE_CTRL = 0x00;
            */
        }
        else                                                                    // 
        {
            printf("Awake\n");
        }
    }
    else
    {
        // ж,ܷ
        //printf("Unknown INT\n");
        USB_INT_FG = 0xFF;                                                      // жϱ־
    }
}

